enchant();	// ライブラリの初期化
window.onload = function(){
	var game = new Game(480, 360);	// 480×360画面(Canvas)を作成
	game.fps = 30;	// フレームレートの設定。30fpsに設定
	// 画像データをあらかじめ読み込ませる
	game.preload("images/droid.png", "images/apple.png", "images/bg0.jpg", "images/bg1.jpg", "images/bg2.jpg", "images/bg3.jpg");
	game.score = 0;	// スコアを入れる変数を用意する
	game.appleCount = 15;	// リンゴの総数を入れておく変数。15個。
	game.stage = 1;			// ゲームのステージ番号を入れておく変数。
	// スコアを表示するラベルを作成
	var scoreLabel = new Label("SCORE : 0");
	scoreLabel.font = "16px Tahoma";
	scoreLabel.color = "white";
	scoreLabel.x = 10;	// X座標
	scoreLabel.y = 5;	// Y座標
	// ステージを表示するラベルを作成
	var stageLabel = new Label("STAGE 1");
	stageLabel.font = "14px Tahoma";
	stageLabel.color = "red";
	stageLabel.x = 400;	// X座標
	stageLabel.y = 330;	// Y座標
	// リンゴを格納する配列
	var apple = new Array();
	// データの読み込みが完了したら処理
	game.onload = function(){
		// 背景の設定
		var bg = new Sprite(480, 360);
		bg.image = game.assets["images/bg1.jpg"];
		bg.x = 0;
		bg.y = 0;
		game.rootScene.addChild(bg);
		game.rootScene.addChild(scoreLabel);
		game.rootScene.addChild(stageLabel);
		// ドロイド君の設定
		var droid = new Sprite(32, 32);
		droid.image = game.assets["images/droid.png"];
		droid.x = 0;	// X座標
		droid.y = game.height - 40;	// Y座標
		game.rootScene.addChild(droid);
		// リンゴを描く
		drawApple();
		// フレームイベントが発生したら処理
		game.rootScene.addEventListener(Event.ENTER_FRAME, function(){
			moveDroid();	// ドロイド君を移動させる
			moveApple();		// 敵を移動させる
			hitCheck();	// リンゴとドロイド君の接触判定
			// =============== 各種処理 ==================
			// ------------ ■ドロイド君を移動させる -----------------
			function moveDroid(){
				if (game.input.right){
					droid.x = droid.x + 4;	 // ドロイド君を右に移動
					game.score = game.score + 1;	// 右に移動するだけで1点加算
					if (droid.x > game.width-8){	// 右端かどうか調べる
						game.score = game.score + 100;	// スコアを加算(100点)
						droid.x = -24;	// 左側に再度座標を設定
						// ステージ数に1を加算
						game.stage = game.stage + 1;
						stageLabel.text = "STAGE "+game.stage;	// 画面に表示
						// 新たなステージ背景に変更する
						var n = game.stage & 3;
						var bgURL = "images/bg"+n+".jpg";
						bg.image = game.assets[bgURL];
					}
				}
				scoreLabel.text = "SCORE : "+game.score;	// 画面に表示
			}
			// ------------ ■リンゴを落下させる -----------------
			function moveApple(){
				for(var i=0; i<game.appleCount; i++){
					apple[i].y = apple[i].y + apple[i].speed;
					apple[i].rotate(5);
					if (apple[i].y > game.height){
						apple[i].y = -32;	// 一番上に座標を再設定
						apple[i].speed = Math.random()*7;	// 落下速度を再設定
					}
				}
			}
			// ------------ ■ドロイド君とリンゴの接触判定を行う -----------------
			function hitCheck(){
				for(var i=0; i<game.appleCount; i++){
					if(droid.within(apple[i], 24)){
						game.stop();
						document.body.style.webkitFilter = "grayscale(100%)";
						alert("ゲームオーバー");
					}
				}
			}
		});
	}
	// ゲーム処理開始
	game.start();
	// ------------ リンゴを描く -----------------
	function drawApple(){
		for(var i=0; i<game.appleCount; i++){
			apple[i] = new Sprite(32, 32);
			apple[i].image = game.assets["images/apple.png"];
			apple[i].x = i * 32+10;	// X座標
			apple[i].y = Math.random()*140;	// Y座標
			apple[i].speed = Math.random()*7;	// 落下速度
			apple[i].rotate(Math.random()* 360);	// 最初に回転させておく
			game.rootScene.addChild(apple[i]);	// シーンに追加
		}
	}
	// ------------ リンゴを描く -----------------
	function stageFilter(n){
		
	}
}
